function df=dfeval(f,f0,x0,dx,Ydata,which_moments)

%function df=dfeval(f,f0,x0,dx)
%calculates numerical gradients -- adapted from Burnside (1999)
%f is the name of the m-file that defines the function
%f0 is the value of the function at the point of differentiation
%x0 is the point of differentiation
%dx is the steplength -- if dx=0, use default

x0=x0(:);
f0=f0(:);

[n,nc]=size(f0);
[k,nc]=size(x0);

df=zeros(n,k);

if dx==0;
	ax=abs(x0);
	
	dx=(max([ax ones(k,1)*(1e-2)]')')*(1e-5);

end;

dxm=eye(k).*(dx*ones(1,k));

for j=1:k;

dxj=dxm(:,j);


if nargin>4;
   df(:,j)=feval(f,x0+dxj,Ydata,which_moments)-feval(f,x0-dxj,Ydata,which_moments);
else;
   df(:,j)=feval(f,x0+dxj)-feval(f,x0-dxj);
end;

end;

df=df./(ones(n,1)*dx'*2);
