% estimates.m
% generates estimated parameters

run environment;
efficient=1;

run mexico_data;
Y_mex=Ydata;
run canada_data;
Y_can=Ydata;



% 1.  Using std dev of income and cons 
which_moments=zeros(1,11);
which_moments([sd_y sd_c])=1;

G=two_parameters(Y_mex,which_moments);
[bmex,Varm]=gmm(G,Y_mex,which_moments,0);
G=two_parameters(Y_can,which_moments);
[bcan,Varc]=gmm(G,Y_can,which_moments,0);

disp(['Using sd(c)']);
disp(['Mexico']);
disp(bmex);
disp(['Canada']);
disp(bcan);

disp(['BC moments:  Mexico']);
disp(predicted_moments_se(bmex(1:2,1),Varm));
disp(['BC moments:  Canada']);
disp(predicted_moments_se(bcan(1:2,1),Varc));



% 2.  Using std dev of income and rho(net exports,income) 
which_moments=zeros(1,11);
which_moments([sd_y rho_nx])=1;

G=two_parameters(Y_mex,which_moments);
bmex=gmm(G,Y_mex,which_moments,0);
G=two_parameters(Y_can,which_moments);
bcan=gmm(G,Y_can,which_moments,0);

disp(['Using rho(nx)']);
disp(['Mexico']);
disp(bmex);
disp(['Canada']);
disp(bcan);

disp(['BC moments:  Mexico']);
disp(predicted_moments_se(bmex(1:2,1),Varm));
disp(['BC moments:  Canada']);
disp(predicted_moments_se(bcan(1:2,1),Varc));






%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Three parameter system
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 3.  Using three moments

which_moments=zeros(1,11);
which_moments([sd_y sd_c rho_c])=1;

G=three_parameters(Y_mex,[sd_y sd_c],rho_c);
bmex=gmm(G([1 2 4]),Y_mex,which_moments,0);
G=three_parameters(Y_can,[sd_y sd_c],rho_c);
bcan=gmm(G([1 2 4]),Y_can,which_moments,0);

disp(['Using sd_y, sd_c, rho(c,y)']);
disp(['Mexico']);
disp(bmex);
disp(['Canada']);
disp(bcan);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Six parameter system
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% 4. Using all moments


which_moments=ones(1,11);
[bmex,Varm]=gmm([0.006,0.025,0.95,0,Gbar0,4],Y_mex,which_moments,efficient);



 [bcan,Varc]=gmm([0.005,0.0019,0.9,0.05,1.0067,4],Y_can,which_moments,efficient);
 
 
disp(['Using all moments']);
disp(['Mexico']);
disp(bmex);
disp(['Canada']);
disp(bcan);

disp(['BC moments:  Mexico']);
disp(predicted_moments_se(bmex(1:6,1),Varm));
disp(['BC moments:  Canada']);
disp(predicted_moments_se(bcan(1:6,1),Varc));

