% three_parameters.m


function G3=three_parameters(Y,two_moments,third_moment,varargin);

global alpha beta sigma delta BYbar gamma psi Gbar0 phi0 rhog0 rhoz0 use_uhlig impulse_response;

tol=1e-3;

which_moments=zeros(1,11);
which_moments([two_moments])=1;

rhog_low=0;

if nargin==3;
   rhog_high=0.4;
else;
   rhog_high=varargin{1};
end;



% calculate empirical moments;

Y(:,1:4)=Y(:,1:4)-ones(length(Y),1)*mean(Y(2:end,1:4));


y=Y(:,1);
c=Y(:,2);
inv=Y(:,3);
nx=Y(:,4);
dy=Y(:,5);


e_m(1)  =  std(y(2:end),1);
e_m(2)  =  std(dy(2:end),1);
e_m(3)  =  std(inv(2:end),1)/e_m(1);
e_m(4)  =  std(c(2:end),1)/e_m(1);
e_m(5)  =  std(nx(2:end),1)/e_m(1);
xx      =  corrcoef([y(2:end),y(1:end-1)]);
e_m(6)  =  xx(1,2);
xx      =  corrcoef([dy(2:end),dy(1:end-1)]);
e_m(7)  =  xx(1,2);
xx      =  corrcoef([y(2:end),nx(2:end)]);
e_m(8)  =  xx(1,2);
xx      =  corrcoef([y(2:end),c(2:end)]);
e_m(9)  =  xx(1,2);
xx      =  corrcoef([y(2:end),inv(2:end)]);
e_m(10) =  xx(1,2);
e_m(11) =  mean(dy(2:end));


% find rho_g;

% check if limits are valid

rhog0=rhog_low;

G=two_parameters(Y,which_moments);

m=key_moments(G);

diff_low=m(third_moment)-e_m(third_moment);

rhog0=rhog_high;

G=two_parameters(Y,which_moments);

m=key_moments(G);

diff_high=m(third_moment)-e_m(third_moment);

notvalid=0;

if (diff_low >0 & diff_high>0) | (diff_low <0 & diff_high<0);
   disp(['rho_g limits not valid']);
   disp([diff_low,diff_high]);
   notvalid=1;
else;   
   
diff=1;

while abs(diff)>tol;
   rhog_mid= rhog_low + (rhog_high-rhog_low)/2;
   rhog0=rhog_mid;
   G=two_parameters(Y,which_moments);
   m=key_moments(G);
   diff = m(third_moment)-e_m(third_moment);
   if diff>0 & diff_low<0;
      rhog_high=rhog_mid;
   elseif diff<0 & diff_low<0;
      rhog_low= rhog_mid;
   elseif diff>0 & diff_low>0;
      rhog_low=rhog_mid;
   elseif diff<0 & diff_low>0;
      rhog_high=rhog_mid;
   end;
   %disp(diff);
end;

end;

G3=[G(:)',rhoz0,rhog_mid];