% two_paramters.m
% solves for sigma_g and sigma_z given two moments


function G=two_parameters(Y,which_moments);

global alpha beta sigma delta BYbar gamma psi Gbar0 phi0 rhog0 rhoz0 use_uhlig impulse_response;

tol=1e-5;

mm=find(which_moments==1);

mm=mm(end);

% calculate empirical moments;

Y(:,1:4)=Y(:,1:4)-ones(length(Y),1)*mean(Y(2:end,1:4));


y=Y(:,1);
c=Y(:,2);
inv=Y(:,3);
nx=Y(:,4);
dy=Y(:,5);


e_m(1)  =  std(y(2:end),1);
e_m(2)  =  std(dy(2:end),1);
e_m(3)  =  std(inv(2:end),1)/e_m(1);
e_m(4)  =  std(c(2:end),1)/e_m(1);
e_m(5)  =  std(nx(2:end),1)/e_m(1);
xx      =  corrcoef([y(2:end),y(1:end-1)]);
e_m(6)  =  xx(1,2);
xx      =  corrcoef([dy(2:end),dy(1:end-1)]);
e_m(7)  =  xx(1,2);
xx      =  corrcoef([y(2:end),nx(2:end)]);
e_m(8)  =  xx(1,2);
xx      =  corrcoef([y(2:end),c(2:end)]);
e_m(9)  =  xx(1,2);
xx      =  corrcoef([y(2:end),inv(2:end)]);
e_m(10) =  xx(1,2);
e_m(11) =  mean(dy(2:end));


% find ratio sigma_g/sigma_z;

r_low=0;

r_high=1e+2;

s_z=0.01;

% check if limits are valid

m=key_moments([s_z,r_low*s_z]);

diff_low=m(mm)-e_m(mm);

m=key_moments([s_z,r_high*s_z]);

diff_high=m(mm)-e_m(mm);

notvalid=0;

if (diff_low >0 & diff_high>0) | (diff_low <0 & diff_high<0);
   disp(['limits not valid']);
   disp([diff_low,diff_high]);
   notvalid=1;
else;   
   
diff=1;

while abs(diff)>tol;
   r_mid= r_low + (r_high-r_low)/2;
   m=key_moments([s_z,r_mid*s_z]);
   diff = m(mm)-e_m(mm);
   if diff>0 & diff_low<0;
      r_high=r_mid;
   elseif diff<0 & diff_low<0;
      r_low= r_mid;
   elseif diff>0 & diff_low>0;
      r_low=r_mid;
   elseif diff<0 & diff_low>0;
      r_high=r_mid;
   end;
end;

ratio=r_mid;
      
end;

if notvalid==0;

% Find level of sigma_z

s_z_low  = eps;
s_z_high = 0.1;

% check if limits are valid

m=key_moments([s_z_low,ratio*s_z_low]);

diff_low=m(1)-e_m(1);

m=key_moments([s_z_high,ratio*s_z_high]);

diff_high=m(1)-e_m(1);

if (diff_low >0 & diff_high>0) | (diff_low <0 & diff_high<0);
   disp(['sigma_z limits not valid']);
else;   
   
diff=1;

while abs(diff)>tol;
   
   s_z_mid= s_z_low + (s_z_high-s_z_low)/2;
   m=key_moments([s_z_mid,ratio*s_z_mid]);
   diff = m(1)/100-e_m(1);
   if diff>0;
      s_z_high=s_z_mid;
   elseif diff<0;
      s_z_low= s_z_mid;
   end;
   
end;

s_z=s_z_mid;

end;


G=[s_z, ratio*s_z];   
   
end;
